<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "umd_specialty_mapping".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "UmdSpecialtyMapping".
 *
 * Columns in table "umd_specialty_mapping" available as properties of the model,
 * followed by relations of table "umd_specialty_mapping" available as properties of the model.
 *
 * @property integer $umd_specialty_id
 * @property integer $sub_specialty_id
 *
 * @property SubSpecialty $subSpecialty
 */
abstract class BaseUmdSpecialtyMapping extends BaseModel
{

    public $Specialty;
    public $umd_specialty_name;
    public $Specialty_name;
    public $Specialty_id;
    public $General;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'umd_specialty_mapping';
    }

    public static function representingColumn()
    {
        return array(
            'umd_specialty_id',
            'sub_specialty_id',
        );
    }

    public function rules()
    {
        return array(
            array('umd_specialty_id, sub_specialty_id', 'required'),
            array('umd_specialty_id, sub_specialty_id', 'numerical', 'integerOnly' => true),
            array('umd_specialty_id, sub_specialty_id', 'safe', 'on' => 'search'),
            array('umd_specialty_i', 'checkCombination'),
        );
    }

    /**
     * @todo fix unused params
     * @todo document
     * @param string $attribute
     * @param array $params
     */
    public function checkCombination($attribute, $params)
    {
        if (!$this->hasErrors()) {  // we only want to authenticate when no input errors
            $combination = UmdSpecialtyMapping::model()->find(
                'umd_specialty_id = ? AND sub_specialty_id = ?',
                array(
                    $this->umd_specialty_id,
                    $this->sub_specialty_id
                )
            );
            if ($combination) {
                $this->addError('sub_specialty_id', 'The combination already exists please check and retry.');
            }
        }
    }

    public function relations()
    {
        return array(
            'subSpecialty' => array(self::BELONGS_TO, 'SubSpecialty', 'sub_specialty_id'),
            'UmdSpecialty' => array(self:: BELONGS_TO, 'UmdSpecialty', 'umd_specialty_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'umd_specialty_id' => Yii::t('app', 'Umd Specialty Id'),
            'UmdSpecialty.name' => Yii::t('app', 'Umd Specialty Name'),
            'Specialty.id' => Yii::t('app', 'Specialty Id'),
            'Specialty.name' => Yii::t('app', 'Specialty Name'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty Id'),
            'subSpecialty.name' => Yii::t('app', 'Sub Specialty Name'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->with[] = 'subSpecialty';
        if (!intval($this->umd_specialty_id) && is_string($this->umd_specialty_id)
                && strlen($this->umd_specialty_id) > 0) {
            $criteria->with[] = 'UmdSpecialty';
            $criteria->addSearchCondition("UmdSpecialty.name", $this->umd_specialty_id);
        } else {
            $criteria->compare('umd_specialty_id', $this->umd_specialty_id);
        }
        if (!intval($this->sub_specialty_id) && is_string($this->sub_specialty_id)
                && strlen($this->sub_specialty_id) > 0) {
            $criteria->addSearchCondition("subSpecialty.name", $this->sub_specialty_id);
        } else {
            $criteria->compare('sub_specialty_id', $this->sub_specialty_id);
        }
        $criteria->compare('subSpecialty.specialty', $this->Specialty_name);


        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'UmdSpecialtyMapping|UmdSpecialtyMappings', $n);
    }

}
